<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>deploy-react-express-2-heroku</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
  </head>
  <body>
    <h1 id="deploy-react-and-express-to-heroku">
      Deploy React and Express to Heroku
    </h1>
    <p>MAY 18, 2018</p>
    <p><em>Updated May 18, 2018</em></p>
    <p>
      You’ve got a React app, and an API server written in Express or something
      else. Now – how do you deploy them both to a server?
    </p>
    <p>There are a few ways to do this:</p>
    <ul>
      <li>
        Keep them together – Express and React files sit on the same machine,
        and Express does double duty: it serves the React files, and it also
        serves API requests.
        <ul>
          <li>e.g., a DigitalOcean VPS running Express on port 80</li>
        </ul>
      </li>
      <li>
        Split them apart – Host the Express API on one machine, and the React
        app on another.
        <ul>
          <li>
            e.g., React app served by Amazon S3, API server running on a
            DigitalOcean VPS
          </li>
        </ul>
      </li>
      <li>
        Put the API behind a proxy – Express and React app files sit on the same
        machine, but served by different servers
        <ul>
          <li>
            e.g., NGINX webserver proxies API requests to the API server, and
            also serves React static files
          </li>
        </ul>
      </li>
    </ul>
    <p>
      This article will cover how to keep them together. We’ll build the Express
      server to serve React’s static files in addition to providing an API, and
      then deploy it to <a href="https://heroku.com/">Heroku</a>. Heroku is easy
      to deploy to and free to get started with.
    </p>
    <h3 id="make-a-heroku-account">Make a Heroku Account</h3>
    <p>
      If you don’t have one already, go <a href="https://heroku.com/">here</a
      > and sign up. It’s free.
    </p>
    <h3 id="install-heroku-toolbelt">Install Heroku Toolbelt</h3>
    <p>
      Heroku comes with a commandline command they call a “toolbelt.” Follow the
      instructions <a href="https://devcenter.heroku.com/articles/heroku-cli"
        >here</a
      > to install it. (On a Mac with <a href="https://brew.sh/">Homebrew</a>,
      just <code>brew install heroku</code>).
    </p>
    <h2 id="the-app">The App</h2>
    <p>
      We’ll build a password generator. Every time you load the app or click Get
      More you’ll get 5 random paswords.
    </p>
    <figure>
      <img
        src="https://daveceddia.com/images/password-generator.gif"
        alt="Finished product"
      />
      <figcaption>Finished product</figcaption>
    </figure>
    <p>
      Just a quick disclaimer: this is just meant as a demo! I don’t recommend
      using some random internet thing that generates passwords <em
        >on the server</em
      > to generate your own real passwords ;)
    </p>
    <h2 id="create-the-express-app">Create the Express App</h2>
    <p>
      Make a parent directory to contain everything. Call
      it <code>rando</code> or whatever you want.
    </p>
    <pre><code>$ mkdir rando; cd rando</code></pre>
    <p>Initialize the project with Yarn or NPM:</p>
    <pre><code>$ yarn init -y
  # or npm init -y</code></pre>
    <p>
      We need 2 packages: Express itself, and a <a
        href="https://www.npmjs.com/package/password-generator"
        >password generator</a
      >. Install those now:
    </p>
    <pre><code>$ yarn add express password-generator</code></pre>
    <p>
      Create a file called <code>index.js</code>, which will be the Express app,
      and type this in:
    </p>
    <pre><code>const express = require(&#39;express&#39;);
const path = require(&#39;path&#39;);
const generatePassword = require(&#39;password-generator&#39;);

const app = express();

// Serve static files from the React app
app.use(express.static(path.join(__dirname, &#39;client/build&#39;)));

// Put all API endpoints under &#39;/api&#39;
app.get(&#39;/api/passwords&#39;, (req, res) =&gt; {
  const count = 5;

  // Generate some passwords
  const passwords = Array.from(Array(count).keys()).map(i =&gt;
    generatePassword(12, false)
  )

  // Return them as json
  res.json(passwords);

  console.log(`Sent ${count} passwords`);
});

// The &quot;catchall&quot; handler: for any request that doesn&#39;t
// match one above, send back React&#39;s index.html file.
app.get(&#39;*&#39;, (req, res) =&gt; {
  res.sendFile(path.join(__dirname+&#39;/client/build/index.html&#39;));
});

const port = process.env.PORT || 5000;
app.listen(port);

console.log(`Password generator listening on ${port}`);</code></pre>
    <p>
      We’re also going to need a “start” script in package.json, so that Heroku
      knows how to start the app. Open <code>package.json</code> and add a
      scripts section at the bottom. The full file should look something like
      this:
    </p>
    <pre><code>{
  &quot;name&quot;: &quot;rando&quot;,
  &quot;version&quot;: &quot;1.0.0&quot;,
  &quot;main&quot;: &quot;index.js&quot;,
  &quot;license&quot;: &quot;MIT&quot;,
  &quot;dependencies&quot;: {
    &quot;express&quot;: &quot;^4.15.3&quot;,
    &quot;password-generator&quot;: &quot;^2.1.0&quot;
  },
  &quot;scripts&quot;: {
    &quot;start&quot;: &quot;node index.js&quot;
  }
}</code></pre>
    <h3 id="test-it">Test It</h3>
    <p>
      It’s always good to make sure things are working as you go along. Much
      better than getting to the end and realizing nothing works. So, let’s try
      it out.
    </p>
    <p>Start up the Express app by running:</p>
    <pre><code>$ yarn start</code></pre>
    <p>
      Open up your browser and go to <a
        href="http://localhost:5000/api/passwords"
        class="uri"
        >http://localhost:5000/api/passwords</a
      >. You should see something like this:
    </p>
    <figure>
      <img
        src="https://daveceddia.com/images/password-generator-working.png"
        alt="Password generator working"
      />
      <figcaption>Password generator working</figcaption>
    </figure>
    <h2 id="set-up-heroku">Set Up Heroku</h2>
    <p>
      Now we’ll deploy the app to Heroku, make sure it works, and then we’ll add
      React to the mix.
    </p>
    <h3 id="git-init">Git Init</h3>
    <p>
      Heroku needs your project to have a Git repository, so we’ll create one
      along with a <code>.gitignore</code> file to ignore node_modules, and then
      commit the code:
    </p>
    <pre><code>$ git init
$ echo node_modules &gt; .gitignore
$ git add .
$ git commit -m &quot;Initial commit&quot;</code></pre>
    <p>Now we’re ready for Heroku. Run its ‘create’ command:</p>
    <pre><code>$ heroku create</code></pre>
    <p>And you’ll see something like this:</p>
    <figure>
      <img
        src="https://daveceddia.com/images/heroku-created.png"
        alt="Heroku created"
      />
      <figcaption>Heroku created</figcaption>
    </figure>
    <p>To make it work, we just need to push up our code by running:</p>
    <pre><code>$ git push heroku master</code></pre>
    <p>
      It will print out a bunch of stuff, and then the app will be live. One of
      the last lines will tell you the URL of the app:
    </p>
    <figure>
      <img
        src="https://daveceddia.com/images/deployed-heroku-url.png"
        alt="My Heroku URL"
      />
      <figcaption>My Heroku URL</figcaption>
    </figure>
    <p>
      Now you can go to <code>&lt;your url&gt;/api/passwords</code> and make
      sure it works.
    </p>
    <p>
      Woohoo! You’ve got an app live on the real internet! Except it’s not very
      nice to use, yet. Let’s add a React frontend now.
    </p>
    <h2 id="create-the-react-app">Create the React App</h2>
    <p>
      We’re going to use <a
        href="https://github.com/facebookincubator/create-react-app"
        >Create React App</a
      > to generate a project. Remember that we decided the React app would live
      in the “client” folder? (we did, back when we set up Express to point to
      “client/build” for static assets).
    </p>
    <p>If you don’t have Create React App installed yet, do that first:</p>
    <pre><code>$ yarn global add create-react-app
# or npm install -g create-react-app</code></pre>
    <p>Generate the React app inside the Express app directory:</p>
    <pre><code>$ create-react-app client</code></pre>
    <p>
      Create React App will proxy API requests from the React app to the Express
      app if we add a “proxy” key in package.json like this:
    </p>
    <pre><code>&quot;proxy&quot;: &quot;http://localhost:5000&quot;</code></pre>
    <p>
      This goes in <code>client/package.json</code>, <em>not</em> in the Express
      app’s package.json, and it will be ignored by Heroku after deploying.
    </p>
    <p>Open up <code>src/App.js</code> and replace it with this:</p>
    <pre><code>import React, { Component } from &#39;react&#39;;
import &#39;./App.css&#39;;

class App extends Component {
  // Initialize state
  state = { passwords: [] }

  // Fetch passwords after first mount
  componentDidMount() {
    this.getPasswords();
  }

  getPasswords = () =&gt; {
    // Get the passwords and store them in state
    fetch(&#39;/api/passwords&#39;)
      .then(res =&gt; res.json())
      .then(passwords =&gt; this.setState({ passwords }));
  }

  render() {
    const { passwords } = this.state;

    return (
      &lt;div className=&quot;App&quot;&gt;
        {/* Render the passwords if we have them */}
        {passwords.length ? (
          &lt;div&gt;
            &lt;h1&gt;5 Passwords.&lt;/h1&gt;
            &lt;ul className=&quot;passwords&quot;&gt;
              {/*
                Generally it&#39;s bad to use &quot;index&quot; as a key.
                It&#39;s ok for this example because there will always
                be the same number of passwords, and they never
                change positions in the array.
              */}
              {passwords.map((password, index) =&gt;
                &lt;li key={index}&gt;
                  {password}
                &lt;/li&gt;
              )}
            &lt;/ul&gt;
            &lt;button
              className=&quot;more&quot;
              onClick={this.getPasswords}&gt;
              Get More
            &lt;/button&gt;
          &lt;/div&gt;
        ) : (
          // Render a helpful message otherwise
          &lt;div&gt;
            &lt;h1&gt;No passwords :(&lt;/h1&gt;
            &lt;button
              className=&quot;more&quot;
              onClick={this.getPasswords}&gt;
              Try Again?
            &lt;/button&gt;
          &lt;/div&gt;
        )}
      &lt;/div&gt;
    );
  }
}

export default App;</code></pre>
    <p>
      You can update the CSS too, if you like (in <code>src/App.css</code>):
    </p>
    <pre><code>.App {
  text-align: center;
  font-family: &quot;Courier New&quot;, monospace;
  width: 100%;
}

h1 {
  font-weight: normal;
  font-size: 42px;
}

.passwords {
  list-style: none;
  padding: 0;
  font-size: 32px;
  margin-bottom: 2em;
}

.more {
  font-size: 32px;
  font-family: &quot;Courier New&quot;, monospace;
  border: 2px solid #000;
  background-color: #fff;
  padding: 10px 25px;
}
.more:hover {
  background-color: #FDD836;
}
.more:active {
  background-color: #FFEFA9;
}</code></pre>
    <p>
      I also recommend opening up <code>src/index.js</code> and removing the
      call to <code>registerServiceWorker()</code> at the bottom, since it can
      cause some confusing caching issues (like preventing you from accessing
      the API endpoints in a browser after you load the React app once).
    </p>
    <p>
      Now start up the React app by running <code>yarn start</code> inside
      the <code>client</code> folder.
    </p>
    <p>
      Make sure the Express app is running too: run <code>yarn start</code> from
      its folder as well.
    </p>
    <p>
      Go to <a href="http://localhost:3000/">http://localhost:3000</a> and the
      app should be working! Now we can deploy the whole thing to Heroku.
    </p>
    <h2 id="deploying-to-heroku">Deploying to Heroku</h2>
    <p>
      When you deploy the app with the <code>git push heroku master</code
      > command, git copies all the checked-in files up to Heroku. There are two
      complications now:
    </p>
    <ul>
      <li>We need to check in the new <code>client</code> code</li>
      <li>
        Express depends on the <em>built</em> client code
        in <code>client/build</code>, which we don’t have yet, and which we’d
        rather not check in to git.
      </li>
    </ul>
    <p>
      What we’ll do is tell Heroku to build the React app after we push up the
      code, and we can do that by adding a “heroku-postbuild” script in the
      top-level (Express app’s) package.json.
    </p>
    <h3 id="using-yarn">Using Yarn</h3>
    <p>If you’re using Yarn, the script looks like this:</p>
    <pre><code>&quot;scripts&quot;: {
  &quot;start&quot;: &quot;node index.js&quot;,
  &quot;heroku-postbuild&quot;: &quot;cd client &amp;&amp; yarn &amp;&amp; yarn run build&quot;
}</code></pre>
    <p>
      This tells Heroku “hey, after you’re done doing what you do, go into the
      client folder and build my React app.” The <code>yarn run build</code
      > script will kick off Create React App’s production build, which will put
      its output files in the <code>client/build</code> folder so Express can
      find them.
    </p>
    <h3 id="using-npm">Using NPM</h3>
    <p>If you’re using NPM, the script will look like this:</p>
    <pre><code>&quot;scripts&quot;: {
  &quot;start&quot;: &quot;node index.js&quot;,
  &quot;heroku-postbuild&quot;: &quot;cd client &amp;&amp; npm install &amp;&amp; npm run build&quot;
}</code></pre>
    <p>
      This tells Heroku “hey, after you’re done doing what you do, go into the
      client folder and build my React app.” The <code>npm run build</code
      > script will kick off Create React App’s production build, which will put
      its output files in the <code>client/build</code> folder so Express can
      find them.
    </p>
    <p>
      Thanks to Matthew Locke and Babajide Ibiayo in the comments for how to get
      this working with NPM.
    </p>
    <h2 id="time-to-deploy">Time to Deploy</h2>
    <p>
      Once you have configured the <code>heroku-postbuild</code> step for Yarn
      (or NPM), add everything to git and commit it. Make sure to run this from
      the top-level <code>rando</code> directory, not
      inside <code>client</code>:
    </p>
    <pre><code>$ git add .
$ git commit -m &quot;Ready for awesome&quot;</code></pre>
    <p>If you run <code>git status</code> now, you should see no red items.</p>
    <p>Then you can deploy the app by running:</p>
    <pre><code>$ git push heroku master</code></pre>
    <p>
      It again prints out your app’s hostname. Mine is <a
        href="https://glacial-brook-33351.herokuapp.com/"
        class="uri"
        >https://glacial-brook-33351.herokuapp.com/</a
      >. Go there and try it out!
    </p>
    <p>Congrats, you’ve got a React + Express app in production ;)</p>
    <h2 id="get-the-code">Get the Code</h2>
    <p>
      The complete app can be found <a href="https://github.com/dceddia/rando"
        >on Github</a
      >, and the README there explains how to deploy it.
    </p>
    <p>
      Check out the <code>npm</code> branch with <code>git checkout npm</code
      > if you want to use NPM. From there, the deploy will differ slightly –
      run <code>git push heroku npm:master</code> to deploy the npm branch
      insead of master.
    </p>
  </body>
</html>
